<?php
require(PINGAUTO_DIR . "functions/spinner.php");
global $wpdb;

/* Class for finding current page url */
class ShowCurrentPage {
  
  public $current_url;
  public $type;
  
  function __construct($result_type) {
  $this->type = $result_type;
  $this->current_url = NULL;  
  }

  function GenrURL() {
  if ($_SERVER['HTTPS'] == on) {
        $protocol = "https://";
      }
      else {
        $protocol = "http://";
      }
      $this->current_url = htmlspecialchars($protocol . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI']);
      
      if ($this->type == "enc") {
        $this->current_url = base64_encode($this->current_url);
      }
    
    return $this->current_url;  
  }
  
}


// Other Variables
$ping_ip = $_SERVER['REMOTE_ADDR'];
$ping_ref = $_SERVER['HTTP_REFERER'];

$show_curr_page = new ShowCurrentPage('plain');
$current_page = $show_curr_page->GenrURL();


# First Clear the IP addr log.

$last24hours = time() - (3600 * 24);
$delete_ips = "DELETE FROM " . PINGAUTO_LOG_IP_TBL . " WHERE time <= '$last24hours' ORDER BY id LIMIT 250";
$delete_res = $wpdb->query($delete_ips);

# Randomly select one active Campaign
$random_campaign = "SELECT `id`, `enc_id`, `ping_pref`, `rss_url` FROM " . PINGAUTO_CAMPAIGNS_TBL . " WHERE `status` = 1 ORDER BY RAND() LIMIT 1";
$random_campaign_res = $wpdb->get_row($random_campaign, ARRAY_N);
if ($wpdb->num_rows == 0) {
  echo ("<!-- No active campaigns to ping - PINGAUTOMATIC -->");
} 
else {

$campaign_id = $random_campaign_res['0'];
$enc_id = $random_campaign_res['1'];
$ping_pref = $random_campaign_res['2'];
$rss_url = $random_campaign_res['3'];
$ping_rss = site_url() . "/?feed=pingautomatic-rss&id=$enc_id";

# Check for Ignore IP list
if (!empty($ping_ip))
{
$ip_query = "SELECT id FROM " . PINGAUTO_IGNORE_IP_TBL . " WHERE id = '$campaign_id' AND addr = INET_ATON('$ping_ip')";
$ip_res = $wpdb->query($ip_query);
if ($wpdb->num_rows > 0)
{
echo ("<!-- IP Address in Ignore List -->");
return;
}
}


# Find if this IP Address has been used for pinging in the last 24 hours time frame
if (!empty($ping_ip))
{
$last24hours = time() - (3600 * 24);
$ip_query2 = "SELECT id FROM " . PINGAUTO_LOG_IP_TBL . " WHERE id = '$campaign_id' AND addr = INET_ATON('$ping_ip') AND time >= '$last24hours'";
$ip_res2 = $wpdb->query($ip_query2);
if ($wpdb->num_rows > 0)
{
echo ("<!-- IP Address already used for pinging in the last 24 hours -->");
return;
}
}

# Find if this Referring Site is in Ignore List
if (!empty($ping_ref))
{
# Extract host name from Referring URL
$parse_hostname = parse_url($ping_ref, PHP_URL_HOST);

$ref_query = "SELECT id FROM " . PINGAUTO_IGNORE_URLS_TBL . " WHERE id = '$campaign_id' AND url = '$parse_hostname'";
$ref_res = $wpdb->query($ref_query);
if ($wpdb->num_rows > 0)
{
echo("<!-- Referring Site in Ignore List -->");
return;
}
} 


# Randomly select a title
$title_query = "SELECT title FROM " . PINGAUTO_TITLES_TBL . " WHERE id = '$campaign_id' ORDER BY RAND() LIMIT 1";
$title_res = $wpdb->get_row($title_query, ARRAY_N);

$title = stripslashes($title_res['0']);


# Spin the title for first ping
$title1 = SpinMyText($title);
$title1 = ucwords(urlencode(trim($title1)));

# Self or Custom Pinging
if ($ping_pref == 0)
{
$url2ping = "$current_page";
}
else
{
# Select a Random Custom URL from DB
$custom_url_query = "SELECT url FROM " . PINGAUTO_URLS_TBL . " WHERE id = '$campaign_id' ORDER BY RAND() LIMIT 1";
$custom_url_res = $wpdb->get_row($custom_url_query, ARRAY_N);
$url2ping = $custom_url_res['0']; 
}

# Prepare first iframe link for Custom URLs or Current Page's URL depending on user defined settings
$pingomatic_link = "http://pingomatic.com/ping/?title=$title1&blogurl=$url2ping&rssurl=$rss_url&chk_weblogscom=on&chk_blogs=on&chk_technorati=on&chk_feedburner=on&chk_syndic8=on&chk_newsgator=on&chk_feedster=on&chk_myyahoo=on&chk_pubsubcom=on&chk_blogdigger=on&chk_blogrolling=on&chk_blogstreet=on&chk_moreover=on&chk_weblogalot=on&chk_icerocket=on&chk_audioweblogs=on&chk_rubhub=on&chk_geourl=on&chk_a2b=on&chk_blogshares=on";
$first_iframe = "<iframe src=\"$pingomatic_link\" border=\"0\" width=\"0\" height=\"0\" scrolling=\"no\" style=\"border:0px;margin:0px;padding:0px;\"></iframe>";

echo ("$first_iframe");

# Now find out if second iframe is required 
$bk_url_query = "SELECT url FROM " . PINGAUTO_BACKLINKS_TBL . " WHERE id = '$campaign_id' ORDER BY RAND() LIMIT 1";
$bk_url_res = $wpdb->get_row($bk_url_query, ARRAY_N);
if ($wpdb->num_rows == 0)
{
echo ("<!-- Second Ping not required as no backlinks added -->");
unset($ping_rss);
}
else
{
$secondurl2ping = $bk_url_res['0'];

# Spin the title for first ping
$title2 = SpinMyText($title);
$title2 = ucwords(urlencode(trim($title2)));

# Prepare Second iframe link for backlinks URL uploaded by the user

$pingomatic_link2 = "http://pingomatic.com/ping/?title=$title2&blogurl=$secondurl2ping&rssurl=$ping_rss&chk_weblogscom=on&chk_blogs=on&chk_technorati=on&chk_feedburner=on&chk_syndic8=on&chk_newsgator=on&chk_feedster=on&chk_myyahoo=on&chk_pubsubcom=on&chk_blogdigger=on&chk_blogrolling=on&chk_blogstreet=on&chk_moreover=on&chk_weblogalot=on&chk_icerocket=on&chk_audioweblogs=on&chk_rubhub=on&chk_geourl=on&chk_a2b=on&chk_blogshares=on";
$second_iframe = "\r\n<iframe src=\"$pingomatic_link2\" border=\"0\" width=\"0\" height=\"0\" scrolling=\"no\" style=\"border:0px;margin:0px;padding:0px;\"></iframe>";
echo ("$second_iframe");
}


$title1 = urldecode(addslashes($title1));
$title2 = urldecode(addslashes($title2));
$timenow = time();

# Now update stats
$stats_query = "INSERT INTO " . PINGAUTO_STATS_TBL . " (id, title1, url1, rss1, title2, url2, rss2, ref, ip_addr, time) VALUES('$campaign_id', '$title1', '$url2ping', '$rss_url', '$title2', '$secondurl2ping', '$ping_rss', '$ping_ref', '$ping_ip', '$timenow')";
$stats_res = $wpdb->query($wpdb->prepare($stats_query));

if (!empty($ping_ip))
{
# Log this IP Address
$insert_ip_addr = "INSERT INTO " . PINGAUTO_LOG_IP_TBL . " (id, addr, time) VALUES('$campaign_id', INET_ATON('$ping_ip'), '$timenow')";
$insert_ip_addr_res = $wpdb->query($wpdb->prepare($insert_ip_addr));
}

}
?>