<!DOCTYPE html
PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>Ping Script - Installation Screen</title>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<link rel="stylesheet" href="../themes/default.css" />
</head>

<body>
<!-- Wrapper/ Layout starts here -->
<div id="wrapper">

<!-- Header starts here -->
<div id = "header">
<img src="../images/logo.jpg" alt="" />
</div>
<!-- Header ends here -->


<div id="content">


<div id="LoginBox">
<h1>Install Ping Script</h1>

<?php
if (isset($_POST['submit']))
{
$admin_name = $_POST['admin_name'];
$admin_pass = $_POST['admin_pass'];
$admin_pass2 = $_POST['admin_pass2'];
$db_server = $_POST['db_server'];
$db_name = $_POST['db_name'];
$db_user = $_POST['db_user'];
$db_pass = $_POST['db_pass'];

# Start Validation
if (strlen($admin_name) < 3 || strlen($admin_name) > 40)
{
$err_msg[] = "Admin Name should be a minimum of 3 characters and not greater than 40 characters";
$err_count++;
}

if (empty($admin_pass))
{
$err_msg[] = "Admin Password is required";
$err_count++;
}

if (empty($admin_pass2))
{
$err_msg[] = "Confirm Admin Password is required";
$err_count++;
}

if (empty($db_server))
{
$err_msg[] = "Database Server Name/Address is required";
$err_count++;
}

if (empty($db_name))
{
$err_msg[] = "Database Name is required";
$err_count++;
}

if (empty($db_user))
{
$err_msg[] = "Database User Name is required";
$err_count++;
}

if (empty($db_pass))
{
$err_msg[] = "Database Password is required";
$err_count++;
}


if ($admin_pass !== $admin_pass2)
{
$err_msg[] = "Admin Password and Confirm Admin Password are not matching";
$err_count++;
}


if ($err_count > 0)
{
echo ("<div id='error'>
<h3>Oops! $err_count error(s) found</h3>
<ol>");
foreach ($err_msg as $err_disp)
{
echo ("<li>$err_disp</li>");
}
echo ("</ol></div>");
}
else
{

# First Write the Configuration File
$create_config = "<?php
\$hostname = \"$db_server\";
\$selectdb = \"$db_name\";
\$dbuser = \"$db_user\";
\$dbpass = \"$db_pass\";
\$con = mysql_connect(\$hostname, \$dbuser, \$dbpass) or die(mysql_error());
\$select = mysql_select_db (\$selectdb, \$con) or die(mysql_error());
?>";


$newfile = fopen("../config.php","w");
$file_creation = fwrite($newfile,"$create_config");
fclose($newfile);

if ($file_creation !== FALSE)
{
echo ("<p style='color:green; text-align:center;'>Configuration file (config.php) successfully written</p>");
}

require_once('../config.php');
require_once('query_arrays.php');

for ($i = 1; $i<=11; $i++)
{
$result = mysql_query($query[$i], $con) or die(mysql_error());
}

if ($i == 12)
{
echo ("<p style='color:green; text-align:center;'>Database tables created</p>");

# Now Add Admin Details

# Convert Admin Pass into md5 value
$enc_admin_pass = md5($admin_pass);
$insert = "INSERT INTO admin(id, name, pass) VALUES(NULL, '$admin_name', '$enc_admin_pass')";
$result = mysql_query($insert, $con) or die(mysql_error());
echo ("<p style='color:green; text-align:center; font-size:1.70em;'>Script Installation was successful.. Please delete the \"install\" folder without fail</p>");
}
else
{
echo ("<p style='color:red; text-align:center;'>Installation Failed as all the database tables could not be CREATED.</p>");
}

}

}
?>


<form method="post" action="<?php echo ("$_SERVER[PHP_SELF]"); ?>">

<table align="center">
<tr>
<td class="field_name">Select a Name for Admin Account:</td><td><input class="px25" type="text" name="admin_name" size="25" maxlength="40" value="<?php echo ("$admin_name"); ?>" /></td>
</tr>

<tr>
<td class="field_name">Choose Password for Admin Account:</td> <td><input class="px25" type="password" name="admin_pass" size="25"  maxlength="25" /></td>
</tr>

<tr>
<td class="field_name">Confirm Password for Admin Account:</td> <td><input class="px25" type="password" name="admin_pass2" size="25"  maxlength="25" /></td>
</tr>

<tr>
<td class="field_name">MySQL Database Server Name/Address:<br />
<span style='color:#000; font-weight:bold;'>(In most hosting companies this is "localhost",<br /> but some may have IP Address as well)</span></td>
<td><input class="px25" type="text" name="db_server" size="25" maxlength="100" value="
<?php
if (empty($db_server))
{
echo ("localhost");
}
else
{
echo ("$db_server");
}
?>" /></td>
</tr>

<tr>
<td class="field_name">MySQL Database Name:</td>
<td><input class="px25" type="text" name="db_name" size="25" maxlength="100" value="<?php echo ("$db_name"); ?>" /></td>
</tr>

<tr>
<td class="field_name">MySQL Database User:</td><td><input class="px25" type="text" name="db_user" size="25" maxlength="50" value="<?php echo ("$db_user"); ?>" /></td>
</tr>

<tr>
<td class="field_name">MySQL Database Password:</td><td><input class="px25" type="password" name="db_pass" size="25" maxlength="50" /></td>
</tr>

<tr>
<td>
<input type="submit" name="submit" value="SUBMIT" /></td><td align="right"><input type="reset" value="RESET" /></td>
</tr>
</table>

</form>










</div>



</div>


<!-- Footer starts here -->
<div id="footer">
<p>&copy; 2011 | Pinger Script Demo</p>
</div>
<!-- Footer ends here -->

</div>
<!-- Wrapper/ Layout ends here -->

</body>
</html>